## clementine 1.4.0~rc1+git867-g9ef681b0e+dfsg

=== debian/changelog ===
clementine (1.4.0~rc1+git867-g9ef681b0e+dfsg-1ubuntu4) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:40:22 +1100

clementine (1.4.0~rc1+git867-g9ef681b0e+dfsg-1ubuntu3) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 04:05:24 +0000

clementine (1.4.0~rc1+git867-g9ef681b0e+dfsg-1ubuntu2) noble; urgency=medium

  * No-change rebuild against libglib2.0-0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 08 Mar 2024 04:05:32 +0000

clementine (1.4.0~rc1+git867-g9ef681b0e+dfsg-1ubuntu1) lunar; urgency=medium

  * Lower optimization level on ppc64el to fix build failure

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 07 Jan 2023 14:00:48 +0100

clementine (1.4.0~rc1+git867-g9ef681b0e+dfsg-1) unstable; urgency=medium

  * New upstream snapshot.
  * Bump Standards-Version to 4.6.2.
  * Acknowledge NMU: 1.4.0~rc1+git347-gfc4cb6fc7+dfsg-2.1. Thanks to Florian
    Ernst.
  * Update debian/watch file. Thanks to Sam Q.

 -- Thomas Pierson <contact@thomaspierson.fr>  Sat, 17 Dec 2022 16:03:09 +0100

clementine (1.4.0~rc1+git347-gfc4cb6fc7+dfsg-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Add explicit Depends on libqt5sql5-sqlite (Closes: #1008312)

 -- Florian Ernst <florian@debian.org>  Thu, 14 Apr 2022 18:00:57 +0200

clementine (1.4.0~rc1+git347-gfc4cb6fc7+dfsg-2) unstable; urgency=medium

  [ Pino Toscano ]
  * Remove the old clementine.xpm, and clementine-16.xpm icons, no more needed
    since the removal of the Debian menu file in 1.3.1+dfsg-1.

  [ Florian Ernst ]
  * Fix FTBFS with GCC-11 by dropping -std=c++0x and -U__STRICT_ANSI__,
    patch taken from upstream. (Closes: #984014)

 -- Thomas Pierson <contact@thomaspierson.fr>  Sat, 12 Feb 2022 18:15:45 +0100

=== debian/control ===
Source: clementine
Section: sound
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Thomas Pierson <contact@thomaspierson.fr>
Build-Depends: cmake (>= 2.6),
               debhelper-compat (= 13),
               libasound2-dev,
               libboost-dev,
               libboost-serialization-dev,
               libcdio-dev,
               libchromaprint-dev,
               libcrypto++-dev,
               libfftw3-dev,
               libglew-dev,
               libgpod-dev,
               libgstreamer1.0-dev,
               libgstreamer-plugins-base1.0-dev,
               liblastfm5-dev,
               libmtp-dev,
               libmygpo-qt-dev (>= 1.1.0-1~),
               libprotobuf-dev,
               libpulse-dev,
               libqt5opengl5-dev,
               libqt5sql5-sqlite,
               libqt5webkit5-dev,
               libqt5x11extras5-dev,
               libsparsehash-dev,
               libsqlite3-dev,
               libtag1-dev (>= 1.8),
               protobuf-compiler,
               qtbase5-private-dev,
               qttools5-dev,
Standards-Version: 4.6.2
Homepage: http://www.clementine-player.org/
Vcs-Git: https://salsa.debian.org/thomaspi-guest/pkg-clementine.git
Vcs-Browser: https://salsa.debian.org/thomaspi-guest/pkg-clementine

Package: clementine
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
         libqt5sql5-sqlite,
         gstreamer1.0-plugins-base,
         gstreamer1.0-plugins-good,
         gstreamer1.0-plugins-ugly
Recommends: gstreamer1.0-alsa | gstreamer1.0-pulseaudio
Suggests: gstreamer1.0-plugins-bad
Description: modern music player and library organizer
 Clementine is a multiplatform music player focusing on a fast and
 easy-to-use interface for searching and playing your music.
 .
 Summary of included features :
  - Search and play your local music library.
  - Listen to internet radio from ROCKRADIO.com, RadioTunes.com,
    IntergalacticFM, SomaFM, Magnatune, Jamendo, Digitally Imported,
    ClassicalRadio.com, JAZZRADIO.com, Icecast and Subsonic servers.
  - Search and play songs you've uploaded to SeaFile, Box, Dropbox, Google
    Drive, and OneDrive.
  - Create smart playlists and dynamic playlists.
  - Tabbed playlists, import and export M3U, XSPF, PLS and ASX.
  - CUE sheet support.
  - Play audio CDs.
  - Visualisations from projectM.
  - Lyrics and artist biographies and photos.
  - Transcode music into MP3, Ogg Vorbis, Ogg Speex, FLAC or AAC.
  - Edit tags on MP3 and OGG files, organise your music.
  - Fetch missing tags from MusicBrainz.
  - Discover and download Podcasts.
  - Download missing album cover art from Last.fm.
  - Native desktop notifications using libnotify.
  - Remote control using an Android device, a Wii Remote, MPRIS or the
    command-line.
  - Copy music to your iPod, iPhone, MTP or mass-storage USB player.
  - Queue manager.
 .

=== debian/rules ===
#!/usr/bin/make -f

export DEB_CXXFLAGS_MAINT_APPEND = -DQT_NO_DEBUG_OUTPUT -DQT_NO_WARNING_OUTPUT
export DEB_VERSION = $(shell dpkg-parsechangelog | egrep '^Version:' | cut -f 2 -d ' ')

ifeq ($(DEB_HOST_ARCH),ppc64el)
  export DEB_CXXFLAGS_MAINT_APPEND = -O2
endif

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- \
	-DHAVE_VISUALISATIONS=OFF \
	-DBUNDLE_PROJECTM_PRESETS=OFF \
	-DUSE_SYSTEM_PROJECTM=ON \
	-DENABLE_VK=OFF \
	-DFORCE_GIT_REVISION=$(DEB_VERSION)

override_dh_auto_clean:
	rm -f dist/Info.plist
	rm -f dist/clementine.spec
	rm -f dist/maketarball.sh
	rm -f dist/windows/clementine.nsi
	rm -f dist/windows/clementine-portable.nsi
	rm -f src/translations/translations.pot
	dh_auto_clean

override_dh_installchangelogs:
	dh_installchangelogs Changelog

override_dh_auto_test:

=== debian/watch ===
version=4
opts=\
repacksuffix=+dfsg,\
repack,compression=xz,\
dversionmangle=s/\+dfsg\d*$//,\
uversionmangle=s/rc/~rc/;s/\-([0-9]+\-g[a-z0-9]+)$/\+git$1/,\
filenamemangle=s/.*\/([\d\.\-a-z]+)\.tar\.gz/clementine-$1.tar.gz/ \
 https://github.com/clementine-player/Clementine/tags .*/v?([\d\.\-a-z]+).tar.gz

## clementine 1.4.1%2Bgit27-g658f34ec4%2Bdfsg

=== debian/changelog ===
clementine (1.4.1+git27-g658f34ec4+dfsg-3ubuntu2) questing; urgency=medium

  * No-change rebuild for libxml2 soname change.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 21 May 2025 10:04:32 +0200

clementine (1.4.1+git27-g658f34ec4+dfsg-3ubuntu1) plucky; urgency=medium

  * Merge with Debian unstable. Remaining changes:
    - Lower optimization level on ppc64el to fix build failure.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Fri, 24 Jan 2025 21:16:25 +0000

clementine (1.4.1+git27-g658f34ec4+dfsg-3) unstable; urgency=medium

  * QA upload.
  * Drop unnecessary Build-Depends: libqt5webkit5-dev.

 -- Bastian Germann <bage@debian.org>  Wed, 22 Jan 2025 23:11:21 +0100

clementine (1.4.1+git27-g658f34ec4+dfsg-2ubuntu1) plucky; urgency=medium

  * Merge with Debian unstable. Remaining changes:
    - Lower optimization level on ppc64el to fix build failure.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Mon, 13 Jan 2025 10:06:53 +0000

clementine (1.4.1+git27-g658f34ec4+dfsg-2) unstable; urgency=medium

  * QA upload.
  * Upload to unstable.

 -- Boyuan Yang <byang@debian.org>  Sun, 12 Jan 2025 12:27:27 -0500

clementine (1.4.1+git27-g658f34ec4+dfsg-2~exp1) experimental; urgency=medium

  * QA upload.
  * debian/patches/:
    + 0009-Try-to-fix-template-mismatch-within-taglib-2-tagread.patch:
      Try to fix build failure with taglib 2 on 32-bit architectures.

 -- Boyuan Yang <byang@debian.org>  Sun, 12 Jan 2025 11:16:35 -0500

clementine (1.4.1+git27-g658f34ec4+dfsg-1ubuntu1) plucky; urgency=medium

  * Merge with Debian unstable. Remaining changes:
    - Lower optimization level on ppc64el to fix build failure.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sun, 12 Jan 2025 21:30:53 +0000

clementine (1.4.1+git27-g658f34ec4+dfsg-1) unstable; urgency=medium

  * QA upload.
  * New upstream release. (Closes: #976016)
  * debian/copyright: Update Files-Excluded field.
  * debian/control: Update Vcs-* fields to use Debian Salsa git repo.
  * debian/control: Build-depends on taglib 2.x libtag-dev. (Closes: #1092686)
  * debian/control: Add optional build-dep libxml2-dev.
  * debian: Apply "wrap-and-sort -abst".
  * debian/patches: Refresh patches.
  * debian/patches:
    + 0008-Disable-HAVE_VISUALISATIONS-unconditionally.patch:
      Set default value of HAVE_VISUALISATIONS to OFF.
  * debian/rules: Drop -DUSE_SYSTEM_PROJECTM=ON, we are not using libprojectm
    for now.
  * debian/rules: Drop -DENABLE_VK=OFF, this option is no longer present in
    upstream build system.
  * debian/rules: Set -DVISUALISATIONS=OFF to explicitly disable this component.

 -- Boyuan Yang <byang@debian.org>  Sat, 11 Jan 2025 15:46:53 -0500

clementine (1.4.0~rc1+git867-g9ef681b0e+dfsg-2) unstable; urgency=medium

  * Orphan package, set maintainer to Debian QA Group. (See: #1092799)
  * Acknowledge NMU: 1.4.0~rc1+git867-g9ef681b0e+dfsg-1.1. Thanks to Florian
    Ernst.

 -- Thomas Pierson <contact@thomaspierson.fr>  Sat, 11 Jan 2025 17:45:55 +0100

clementine (1.4.0~rc1+git867-g9ef681b0e+dfsg-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS with GCC-14 by turning off the compiler warning flag that causes
    it, which quite plausibly just triggers a false positive.
    Thanks to Ben Harris <bjh21@bjh21.me.uk>. (Closes: #1088037)

 -- Florian Ernst <florian@debian.org>  Sat, 21 Dec 2024 11:53:06 +0100

=== debian/control ===
Source: clementine
Section: sound
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian QA Group <packages@qa.debian.org>
Build-Depends:
 debhelper-compat (= 13),
 cmake (>= 2.6),
 libasound2-dev,
 libboost-dev,
 libboost-serialization-dev,
 libcdio-dev,
 libchromaprint-dev,
 libcrypto++-dev,
 libfftw3-dev,
 libglew-dev,
 libgpod-dev,
 libgstreamer-plugins-base1.0-dev,
 libgstreamer1.0-dev,
 liblastfm5-dev,
 libmtp-dev,
 libmygpo-qt-dev (>= 1.1.0-1~),
 libprotobuf-dev,
 libpulse-dev,
 libqt5opengl5-dev,
 libqt5sql5-sqlite,
 libqt5x11extras5-dev,
 libsparsehash-dev,
 libsqlite3-dev,
 libtag-dev,
 libxml2-dev,
 protobuf-compiler,
 qtbase5-private-dev,
 qttools5-dev,
Standards-Version: 4.7.0
Homepage: https://www.clementine-player.org/
Vcs-Git: https://salsa.debian.org/debian/clementine.git
Vcs-Browser: https://salsa.debian.org/debian/clementine

Package: clementine
Architecture: any
Depends:
 gstreamer1.0-plugins-base,
 gstreamer1.0-plugins-good,
 gstreamer1.0-plugins-ugly,
 libqt5sql5-sqlite,
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 gstreamer1.0-alsa | gstreamer1.0-pulseaudio,
Suggests:
 gstreamer1.0-plugins-bad,
Description: modern music player and library organizer
 Clementine is a multiplatform music player focusing on a fast and
 easy-to-use interface for searching and playing your music.
 .
 Summary of included features :
  - Search and play your local music library.
  - Listen to internet radio from ROCKRADIO.com, RadioTunes.com,
    IntergalacticFM, SomaFM, Magnatune, Jamendo, Digitally Imported,
    ClassicalRadio.com, JAZZRADIO.com, Icecast and Subsonic servers.
  - Search and play songs you've uploaded to SeaFile, Box, Dropbox, Google
    Drive, and OneDrive.
  - Create smart playlists and dynamic playlists.
  - Tabbed playlists, import and export M3U, XSPF, PLS and ASX.
  - CUE sheet support.
  - Play audio CDs.
  - Visualisations from projectM.
  - Lyrics and artist biographies and photos.
  - Transcode music into MP3, Ogg Vorbis, Ogg Speex, FLAC or AAC.
  - Edit tags on MP3 and OGG files, organise your music.
  - Fetch missing tags from MusicBrainz.
  - Discover and download Podcasts.
  - Download missing album cover art from Last.fm.
  - Native desktop notifications using libnotify.
  - Remote control using an Android device, a Wii Remote, MPRIS or the
    command-line.
  - Copy music to your iPod, iPhone, MTP or mass-storage USB player.
  - Queue manager.

## clementine 1.4.1+git27

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13.0)
project(clementine)

cmake_policy(SET CMP0053 OLD)

include(CheckCXXCompilerFlag)
include(FindPkgConfig)
include(cmake/C++11Compat.cmake)
include(cmake/Summary.cmake)
include(cmake/Version.cmake)
include(cmake/Deb.cmake)
include(cmake/SpotifyVersion.cmake)
include(cmake/OptionalSource.cmake)
include(cmake/Format.cmake)
set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON CACHE INTERNAL "")

set(CMAKE_CXX_STANDARD 17)

if (CMAKE_CXX_COMPILER MATCHES ".*clang")
  set(CMAKE_COMPILER_IS_CLANGXX 1)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-uninitialized")
  if (APPLE)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --stdlib=libc++")
  endif ()
endif ()

find_program(CCACHE_EXECUTABLE NAMES ccache)
if (CCACHE_EXECUTABLE)
  message(STATUS "ccache found: will be used for compilation and linkage")
  SET_PROPERTY(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ${CCACHE_EXECUTABLE})
  SET_PROPERTY(GLOBAL PROPERTY RULE_LAUNCH_LINK ${CCACHE_EXECUTABLE})
endif ()

if (${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
  set(LINUX ON)
endif()
if (${CMAKE_SYSTEM_NAME} STREQUAL "FreeBSD")
  set(FREEBSD ON)
endif()

set(OpenGL_GL_PREFERENCE LEGACY)
find_package(OpenGL)
if(OPENGL_FOUND)
  set(HAVE_OPENGL ON)
endif(OPENGL_FOUND)
find_package(Boost REQUIRED)
find_package(Gettext REQUIRED)
find_package(PkgConfig REQUIRED)
find_package(protobuf)
if(NOT protobuf_FOUND)
  find_package(Protobuf REQUIRED)
endif()
find_package(FFTW3)
find_package(ALSA)
if (NOT APPLE)
  find_package(X11)
endif()
if(X11_FOUND)
  set(HAVE_X11 ON)
endif()

find_library(PROTOBUF_STATIC_LIBRARY libprotobuf.a libprotobuf)

pkg_check_modules(CDIO libcdio)
pkg_check_modules(CHROMAPRINT REQUIRED libchromaprint)
pkg_check_modules(GIO gio-2.0)
pkg_check_modules(GLIB REQUIRED glib-2.0)
pkg_check_modules(GOBJECT REQUIRED gobject-2.0)
pkg_check_modules(GSTREAMER REQUIRED gstreamer-1.0)
pkg_check_modules(GSTREAMER_APP REQUIRED gstreamer-app-1.0)
pkg_check_modules(GSTREAMER_AUDIO REQUIRED gstreamer-audio-1.0)
pkg_check_modules(GSTREAMER_BASE REQUIRED gstreamer-base-1.0)
pkg_check_modules(GSTREAMER_TAG REQUIRED gstreamer-tag-1.0)
pkg_check_modules(GSTREAMER_PBUTILS REQUIRED gstreamer-pbutils-1.0)
pkg_check_modules(LIBGPOD libgpod-1.0>=0.7.92)
pkg_check_modules(LIBMTP libmtp>=1.0)
pkg_check_modules(LIBMYGPO_QT5 libmygpo-qt5>=1.0.9)
pkg_check_modules(LIBPULSE libpulse)
pkg_check_modules(LIBXML libxml-2.0)
pkg_check_modules(TAGLIB taglib)

find_package(ZLIB REQUIRED)

find_library(LASTFM5_LIBRARIES lastfm5)
find_path(LASTFM5_INCLUDE_DIRS lastfm5/ws.h)
find_path(LASTFM51_INCLUDE_DIRS lastfm5/Track.h)

find_path(SPARSEHASH_INCLUDE_DIRS google/sparsetable)

# QT
set(QT_MIN_VERSION 5.6.0)
find_package(Qt5 ${QT_MIN_VERSION} REQUIRED COMPONENTS Core Concurrent Widgets Network Sql Xml OpenGL Test)
if(HAVE_X11)
  find_package(Qt5 ${QT_MIN_VERSION} REQUIRED COMPONENTS X11Extras)
  find_package(Qt5DBus ${QT_MIN_VERSION})
endif()
if(APPLE)
  find_package(Qt5 REQUIRED COMPONENTS MacExtras)
endif()
if(WIN32)
  find_package(Qt5 REQUIRED COMPONENTS WinExtras)
endif()

set(QT_LIBRARIES Qt5::Core Qt5::Concurrent Qt5::Widgets Qt5::Network Qt5::Sql Qt5::Xml Qt5::OpenGL)

if(Qt5DBus_FOUND)
  set(QT_LIBRARIES ${QT_LIBRARIES} Qt5::DBus)
  get_target_property(QT_DBUSXML2CPP_EXECUTABLE Qt5::qdbusxml2cpp LOCATION)
endif()
if(HAVE_X11)
  set(QT_LIBRARIES ${QT_LIBRARIES} Qt5::X11Extras)
endif()
if(APPLE)
  set(QT_LIBRARIES ${QT_LIBRARIES} Qt5::MacExtras)
endif()
if(WIN32)
  set(QT_LIBRARIES ${QT_LIBRARIES} Qt5::WinExtras)
endif()

find_package(Qt5LinguistTools CONFIG)
if (Qt5LinguistTools_FOUND)
  set(QT_LCONVERT_EXECUTABLE Qt5::lconvert)
endif()


# Only use system taglib if it's greater than 1.11.1
# There is a bug in version 1.11.1 corrupting Ogg files, see: https://github.com/taglib/taglib/issues/864
# If you decide to use the systems taglib, make sure it has been patched with the following commit:
# https://github.com/taglib/taglib/commit/9336c82da3a04552168f208cd7a5fa4646701ea4
# The current taglib in 3rdparty also has the following features used by Clementine:
# - Audio file detection by content.
#
if (TAGLIB_VERSION VERSION_GREATER 1.11.1)
  option(USE_SYSTEM_TAGLIB "Use system taglib" ON)
else()
  option(USE_SYSTEM_TAGLIB "Use system taglib" OFF)
endif()

if (TAGLIB_FOUND AND USE_SYSTEM_TAGLIB)
  if (TAGLIB_VERSION VERSION_GREATER 1.11.1)
    message(STATUS "Using system taglib library")
  else()
    message(WARNING "Using system taglib library. Version 1.11.1 or less has a bug corrupting Ogg files, make sure your systems version has been patched!")
  endif()
  set(CMAKE_REQUIRED_INCLUDES "${TAGLIB_INCLUDE_DIRS}")
  set(CMAKE_REQUIRED_LIBRARIES "${TAGLIB_LIBRARIES}")
  check_cxx_source_compiles("#include <opusfile.h>
      int main() { char *s; TagLib::Ogg::Opus::File opusfile(s); return 0;}" TAGLIB_HAS_OPUS)
  set(CMAKE_REQUIRED_INCLUDES)
  set(CMAKE_REQUIRED_LIBRARIES)
else()
  message(STATUS "Using builtin taglib library")
  set(TAGLIB_VERSION 1.11.1)
  set(TAGLIB_INCLUDE_DIRS "${CMAKE_BINARY_DIR}/3rdparty/taglib/headers/taglib/;${CMAKE_BINARY_DIR}/3rdparty/taglib/headers/")
  set(TAGLIB_LIBRARY_DIRS "")
  set(TAGLIB_LIBRARIES tag)
  set(TAGLIB_HAS_OPUS ON)
  add_subdirectory(3rdparty/utf8-cpp)
  add_subdirectory(3rdparty/taglib)
  add_definitions(-DTAGLIB_STATIC)
endif()

if(LASTFM5_INCLUDE_DIRS AND LASTFM51_INCLUDE_DIRS)
  set(HAVE_LIBLASTFM1 ON)
endif()

if (APPLE)
  find_library(SPARKLE Sparkle)

  add_subdirectory(3rdparty/SPMediaKeyTap)
  set(SPMEDIAKEYTAP_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/SPMediaKeyTap)
  set(SPMEDIAKEYTAP_LIBRARIES SPMediaKeyTap)
endif (APPLE)

find_package(Threads)

if(${CMAKE_BUILD_TYPE} MATCHES "Release")
  add_definitions(-DNDEBUG)
  add_definitions(-DQT_NO_DEBUG_OUTPUT)
  add_definitions(-DQT_NO_WARNING_OUTPUT)
endif(${CMAKE_BUILD_TYPE} MATCHES "Release")

# Set up definitions and paths
add_definitions(${QT_DEFINITIONS})
link_directories(${TAGLIB_LIBRARY_DIRS})
link_directories(${GSTREAMER_LIBRARY_DIRS})

# Top level headers and generated headers
include_directories(${PROJECT_SOURCE_DIR}/include)
include_directories(${PROJECT_BINARY_DIR}/include)

include_directories(${Boost_INCLUDE_DIRS})
include_directories(${TAGLIB_INCLUDE_DIRS})
include_directories(${GSTREAMER_INCLUDE_DIRS})
include_directories(${GSTREAMER_APP_INCLUDE_DIRS})
include_directories(${GSTREAMER_AUDIO_INCLUDE_DIRS})
include_directories(${GSTREAMER_BASE_INCLUDE_DIRS})
include_directories(${GSTREAMER_TAG_INCLUDE_DIRS})
include_directories(${GSTREAMER_PBUTILS_INCLUDE_DIRS})
include_directories(${GLIB_INCLUDE_DIRS})
include_directories(${GLIBCONFIG_INCLUDE_DIRS})
include_directories(${LIBXML_INCLUDE_DIRS})

if (WIN32)
  # RC compiler
  string(REPLACE "gcc" "windres" CMAKE_RC_COMPILER_INIT ${CMAKE_C_COMPILER})
  enable_language(RC)
  SET(CMAKE_RC_COMPILE_OBJECT "<CMAKE_RC_COMPILER> -O coff -o <OBJECT> <SOURCE> -I ${CMAKE_SOURCE_DIR}/dist/windows")
endif(WIN32)

add_definitions(-DQT_NO_CAST_TO_ASCII -DQT_STRICT_ITERATORS)

# Translations stuff
find_program(GETTEXT_XGETTEXT_EXECUTABLE xgettext PATHS /target/bin)
if(NOT GETTEXT_XGETTEXT_EXECUTABLE)
  message(FATAL_ERROR "Could not find xgettext executable")
endif(NOT GETTEXT_XGETTEXT_EXECUTABLE)
find_program(GETTEXT_MSGMERGE_EXECUTABLE msgmerge PATHS /target/bin)
if(NOT GETTEXT_MSGMERGE_EXECUTABLE)
  message(FATAL_ERROR "Could not find msgmerge executable")
endif(NOT GETTEXT_MSGMERGE_EXECUTABLE)
find_program(GETTEXT_MSGFMT_EXECUTABLE msgfmt PATHS /target/bin)
if(NOT GETTEXT_MSGFMT_EXECUTABLE)
  message(FATAL_ERROR "Could not find msgfmt executable")
endif(NOT GETTEXT_MSGFMT_EXECUTABLE)

# Optional bits
if(WIN32)
  option(ENABLE_WIN32_CONSOLE "Show the windows console even outside Debug mode" OFF)
endif(WIN32)

optional_component(BREAKPAD OFF "Crash reporting")

optional_component(GOOGLE_DRIVE ON "Google Drive support"
  DEPENDS "Google sparsehash" SPARSEHASH_INCLUDE_DIRS
  DEPENDS "Taglib 1.8" "TAGLIB_VERSION VERSION_GREATER 1.7.999"
)

optional_component(DROPBOX ON "Dropbox support"
  DEPENDS "Google sparsehash" SPARSEHASH_INCLUDE_DIRS
  DEPENDS "Taglib 1.8" "TAGLIB_VERSION VERSION_GREATER 1.7.999"
)

optional_component(SKYDRIVE ON "Skydrive support"
  DEPENDS "Google sparsehash" SPARSEHASH_INCLUDE_DIRS
  DEPENDS "Taglib 1.8" "TAGLIB_VERSION VERSION_GREATER 1.7.999"
)

optional_component(BOX ON "Box support"
  DEPENDS "Google sparsehash" SPARSEHASH_INCLUDE_DIRS
  DEPENDS "Taglib 1.8" "TAGLIB_VERSION VERSION_GREATER 1.7.999"
)

optional_component(SEAFILE ON "Seafile support"
  DEPENDS "Google sparsehash" SPARSEHASH_INCLUDE_DIRS
  DEPENDS "Taglib 1.8" "TAGLIB_VERSION VERSION_GREATER 1.7.999"
)

optional_component(AUDIOCD ON "Devices: Audio CD support"
  DEPENDS "libcdio" CDIO_FOUND
)

optional_component(LIBGPOD ON "Devices: iPod classic support"
  DEPENDS "libgpod" LIBGPOD_FOUND
)

optional_component(GIO ON "Devices: GIO device backend"
  DEPENDS "libgio" GIO_FOUND
  DEPENDS "Linux or Windows" "NOT APPLE"
)

optional_component(LIBMTP ON "Devices: MTP support"
  DEPENDS "libmtp" LIBMTP_FOUND
)

optional_component(LIBLASTFM ON "Last.fm support"
  DEPENDS "liblastfm" LASTFM5_LIBRARIES LASTFM5_INCLUDE_DIRS
)

optional_component(DBUS ON "D-Bus support"
  DEPENDS "Qt5DBus" Qt5DBus_FOUND
)

optional_component(WIIMOTEDEV ON "Wiimote support"
  DEPENDS "D-Bus support" Qt5DBus_FOUND
)

optional_component(UDISKS2 ON "Devices: UDisks2 backend"
  DEPENDS "D-Bus support" Qt5DBus_FOUND
)

optional_component(MOODBAR ON "Moodbar support"
  DEPENDS "fftw3" FFTW3_FOUND
)

optional_component(SPARKLE ON "Sparkle integration"
  DEPENDS "macOS" APPLE
  DEPENDS "Sparkle" SPARKLE
)

optional_component(ALSA ON "ALSA integration"
  DEPENDS "ALSA" ALSA_FOUND
)

optional_component(LIBPULSE ON "Pulse audio integration"
  DEPENDS "libpulse" LIBPULSE_FOUND
)

optional_component(VISUALISATIONS ON "Visualisations"
  DEPENDS "opengl" OPENGL_FOUND
)

optional_component(TRANSLATIONS ON "Translations"
  DEPENDS "gettext" GETTEXT_XGETTEXT_EXECUTABLE
  DEPENDS "Qt5LinguistTools" Qt5LinguistTools_FOUND
)

option(USE_BUNDLE "Bundle macos/windows dependencies" ON)
if (APPLE AND USE_BUNDLE AND NOT USE_BUNDLE_DIR)
  set(USE_BUNDLE_DIR "../PlugIns")
endif()

# Remove GLU and GL from the link line - they're not really required
# and don't exist on my mingw toolchain
list(REMOVE_ITEM QT_LIBRARIES "-lGLU -lGL")

option(USE_SYSTEM_PROJECTM "Don't set this option unless your system projectM library has been compiled with the Clementine patches in 3rdparty" OFF)
option(BUNDLE_PROJECTM_PRESETS "Install Clementine's own copies of libprojectm presets - disable this if you want to use a system package instead" ON)

if(HAVE_VISUALISATIONS)
  # When/if upstream accepts our patches then these options can be used to link
  # to system installed projectM instead.
  if(USE_SYSTEM_PROJECTM)
    pkg_check_modules(LIBPROJECTM libprojectM)
  else(USE_SYSTEM_PROJECTM)
    add_subdirectory(3rdparty/libprojectm)
    set(LIBPROJECTM_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/libprojectm)
    set(LIBPROJECTM_LIBRARIES projectM)
  endif(USE_SYSTEM_PROJECTM)
endif(HAVE_VISUALISATIONS)


# Build our copy of QSqlLiteDriver.
# We do this because we can't guarantee that the driver shipped with Qt exposes the
# raw sqlite3_ functions required for FTS support. This way we know that those symbols
# exist at compile-time and that our code links to the same sqlite library as the
# Qt driver.
add_subdirectory(3rdparty/qsqlite)
include_directories("3rdparty/qsqlite")

# When/if upstream accepts our patches then these options can be used to link
# to system installed qtsingleapplication instead.
option(USE_SYSTEM_QTSINGLEAPPLICATION "Use the system-provided QtSingleApplication library (needs to have clementine patches, but these seem to be in Qt5)" OFF)
if(USE_SYSTEM_QTSINGLEAPPLICATION)
  find_path(QTSINGLEAPPLICATION_INCLUDE_DIRS qtsingleapplication.h PATH_SUFFIXES qt5/QtSolutions REQUIRED)

=== dist/CMakeLists.txt ===
execute_process(COMMAND env LC_ALL="en_US.utf8" date "+%a %b %d %Y" OUTPUT_VARIABLE RPM_DATE OUTPUT_STRIP_TRAILING_WHITESPACE)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/clementine.spec.in
               ${CMAKE_CURRENT_SOURCE_DIR}/clementine.spec @ONLY)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Info.plist.in
               ${CMAKE_CURRENT_SOURCE_DIR}/Info.plist)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/maketarball.sh.in
               ${CMAKE_CURRENT_SOURCE_DIR}/maketarball.sh @ONLY)

# Create two installers, one for the normal version, one for the portable one
# Create normal installer
set(PORTABLE ";")
set(NORMAL "")
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/windows/clementine.nsi.in
               ${CMAKE_CURRENT_SOURCE_DIR}/windows/clementine.nsi @ONLY)

# Create portable installer
set(PORTABLE "")
set(NORMAL ";")
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/windows/clementine.nsi.in
               ${CMAKE_CURRENT_SOURCE_DIR}/windows/clementine-portable.nsi @ONLY)


# windows/windres.rc is done by src/CMakeLists.txt
set(APP_ID "org.clementine_player.Clementine")
if(EXISTS /etc/lsb-release)
  file(READ "/etc/lsb-release" LSB_RELEASE_CONTENTS)
  string(REGEX MATCH "DISTRIB_ID=Ubuntu" IS_UBUNTU ${LSB_RELEASE_CONTENTS})
  if(IS_UBUNTU)
    set(INSTALL_UBUNTU_ICONS_DEFAULT ON)
  else(IS_UBUNTU)
    set(INSTALL_UBUNTU_ICONS_DEFAULT OFF)
  endif(IS_UBUNTU)
else(EXISTS /etc/lsb-release)
  set(INSTALL_UBUNTU_ICONS_DEFAULT OFF)
endif(EXISTS /etc/lsb-release)

option(INSTALL_UBUNTU_ICONS "Install the Ubuntu themed monochrome panel icons" ${INSTALL_UBUNTU_ICONS_DEFAULT})

if (NOT APPLE)
  install(FILES clementine_64.png
    DESTINATION share/icons/hicolor/64x64/apps/
    RENAME ${APP_ID}.png
  )

  install(FILES clementine_128.png
    DESTINATION share/icons/hicolor/128x128/apps/
    RENAME ${APP_ID}.png
  )

  install(FILES ../data/icon.svg
    DESTINATION share/icons/hicolor/scalable/apps/
    RENAME ${APP_ID}.svg
  )

  install(FILES ${APP_ID}.desktop
    DESTINATION share/applications
  )

  install(FILES clementine-itms.protocol
                clementine-itpc.protocol
                clementine-feed.protocol
                clementine-zune.protocol
    DESTINATION share/kservices5
  )

  install(FILES ${APP_ID}.appdata.xml
    DESTINATION share/metainfo
  )

  if(INSTALL_UBUNTU_ICONS)
    foreach(icon clementine-panel.png clementine-panel-grey.png)
      foreach(theme ubuntu-mono-dark ubuntu-mono-light)
        install(FILES icons/${theme}/${icon}
          DESTINATION share/icons/${theme}/apps/24/
        )
      endforeach(theme)
    endforeach(icon)
  endif(INSTALL_UBUNTU_ICONS)
endif (NOT APPLE)

=== src/CMakeLists.txt ===

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Woverloaded-virtual -Wall -Wno-sign-compare -Wno-deprecated-declarations -Wno-unused-local-typedefs -Wno-unused-private-field -Wno-unknown-warning-option")

option(BUILD_WERROR "Build with -Werror" ON)

if(BUILD_WERROR)
  if (LINUX)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror")
  endif (LINUX)
endif(BUILD_WERROR)

include_directories(${CMAKE_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR})
include_directories(../3rdparty/gmock/gtest/include)

# Activate fast QString concatenation
add_definitions(-DQT_USE_QSTRINGBUILDER)
add_definitions(-DQT_NO_URL_CAST_FROM_STRING)
add_definitions(-DBOOST_BIND_NO_PLACEHOLDERS)

include_directories(${CMAKE_BINARY_DIR})
include_directories(${GLIB_INCLUDE_DIRS})
include_directories(${LIBXML_INCLUDE_DIRS})
include_directories(${GOBJECT_INCLUDE_DIRS})
include_directories(${QTSINGLEAPPLICATION_INCLUDE_DIRS})
include_directories(${QTIOCOMPRESSOR_INCLUDE_DIRS})
include_directories(${QXT_INCLUDE_DIRS})
include_directories(${CHROMAPRINT_INCLUDE_DIRS})
include_directories(${MYGPOQT5_INCLUDE_DIRS})

if (HAVE_VISUALISATIONS)
  find_package(OpenGL REQUIRED)
  include_directories(${OPENGL_INCLUDE_DIR})
  include_directories(${LIBPROJECTM_INCLUDE_DIRS})
endif(HAVE_VISUALISATIONS)

if(HAVE_LIBLASTFM)
  include_directories(${LASTFM5_INCLUDE_DIRS})
endif(HAVE_LIBLASTFM)

if(HAVE_BREAKPAD)
  include_directories(../3rdparty/google-breakpad)
endif(HAVE_BREAKPAD)

include_directories(${CMAKE_SOURCE_DIR}/ext/libclementine-common)
include_directories(${CMAKE_SOURCE_DIR}/ext/libclementine-tagreader)
include_directories(${CMAKE_BINARY_DIR}/ext/libclementine-tagreader)
include_directories(${CMAKE_SOURCE_DIR}/ext/libclementine-remote)
include_directories(${CMAKE_BINARY_DIR}/ext/libclementine-remote)

include(../cmake/ParseArguments.cmake)

if(HAVE_TRANSLATIONS)
  include(../cmake/Translations.cmake)
endif(HAVE_TRANSLATIONS)

set(SOURCES
  analyzers/analyzerbase.cpp
  analyzers/analyzercontainer.cpp
  analyzers/baranalyzer.cpp
  analyzers/blockanalyzer.cpp
  analyzers/boomanalyzer.cpp
  analyzers/rainbowanalyzer.cpp
  analyzers/sonogram.cpp
  analyzers/turbine.cpp
  analyzers/fht.cpp

  core/appearance.cpp
  core/application.cpp
  core/backgroundstreams.cpp
  core/commandlineoptions.cpp
  core/crashreporting.cpp
  core/database.cpp
  core/deletefiles.cpp
  core/filesystemmusicstorage.cpp
  core/filesystemwatcherinterface.cpp
  core/globalshortcutbackend.cpp
  core/globalshortcuts.cpp
  core/gnomeglobalshortcutbackend.cpp
  core/kglobalaccelglobalshortcutbackend.cpp
  core/mergedproxymodel.cpp
  core/metatypes.cpp
  core/multisortfilterproxy.cpp
  core/musicstorage.cpp
  core/network.cpp
  core/networkproxyfactory.cpp
  core/organise.cpp
  core/organiseformat.cpp
  core/player.cpp
  core/qtfslistener.cpp
  core/qxtglobalshortcutbackend.cpp
  core/scopedtransaction.cpp
  core/settingsprovider.cpp
  core/signalchecker.cpp
  core/song.cpp
  core/songloader.cpp
  core/songpathparser.cpp
  core/stylesheetloader.cpp
  core/tagreaderclient.cpp
  core/taskmanager.cpp
  core/thread.cpp
  core/urlhandler.cpp
  core/utilities.cpp

  covers/albumcoverexporter.cpp
  covers/albumcoverfetcher.cpp
  covers/albumcoverfetchersearch.cpp
  covers/albumcoverloader.cpp
  covers/discogscoverprovider.cpp
  covers/coverexportrunnable.cpp
  covers/coverprovider.cpp
  covers/coverproviders.cpp
  covers/coversearchstatistics.cpp
  covers/coversearchstatisticsdialog.cpp
  covers/currentartloader.cpp
  covers/kittenloader.cpp
  covers/musicbrainzcoverprovider.cpp

  devices/connecteddevice.cpp
  devices/devicedatabasebackend.cpp
  devices/devicelister.cpp
  devices/devicemanager.cpp
  devices/deviceproperties.cpp
  devices/devicestatefiltermodel.cpp
  devices/deviceview.cpp
  devices/deviceviewcontainer.cpp
  devices/filesystemdevice.cpp
  devices/deviceinfo.cpp

  engines/devicefinder.cpp
  engines/enginebase.cpp
  engines/gstengine.cpp
  engines/gstenginedebug.cpp
  engines/gstenginepipeline.cpp
  engines/gstelementdeleter.cpp
  engines/gstpipelinebase.cpp
  engines/pipelineview.cpp

  globalsearch/digitallyimportedsearchprovider.cpp
  globalsearch/globalsearch.cpp
  globalsearch/globalsearchitemdelegate.cpp
  globalsearch/globalsearchmodel.cpp
  globalsearch/globalsearchsettingspage.cpp
  globalsearch/globalsearchsortmodel.cpp
  globalsearch/globalsearchview.cpp
  globalsearch/icecastsearchprovider.cpp
  globalsearch/librarysearchprovider.cpp
  globalsearch/savedradiosearchprovider.cpp
  globalsearch/searchprovider.cpp
  globalsearch/searchproviderstatuswidget.cpp
  globalsearch/simplesearchprovider.cpp
  globalsearch/somafmsearchprovider.cpp
  globalsearch/intergalacticfmsearchprovider.cpp
  globalsearch/radiobrowsersearchprovider.cpp
  globalsearch/suggestionwidget.cpp
  globalsearch/urlsearchprovider.cpp

  internet/core/cloudfilesearchprovider.cpp
  internet/core/cloudfileservice.cpp
  internet/digitally/digitallyimportedclient.cpp
  internet/digitally/digitallyimportedservicebase.cpp
  internet/digitally/digitallyimportedsettingspage.cpp
  internet/digitally/digitallyimportedurlhandler.cpp
  internet/core/geolocator.cpp
  internet/icecast/icecastbackend.cpp
  internet/icecast/icecastfilterwidget.cpp
  internet/icecast/icecastmodel.cpp
  internet/icecast/icecastservice.cpp
  internet/core/internetmodel.cpp
  internet/core/internetplaylistitem.cpp
  internet/core/internetservice.cpp
  internet/core/internetsettingscategory.cpp
  internet/core/internetshowsettingspage.cpp
  internet/core/internetview.cpp
  internet/core/internetviewcontainer.cpp
  internet/jamendo/jamendodynamicplaylist.cpp
  internet/jamendo/jamendoplaylistitem.cpp
  internet/jamendo/jamendoservice.cpp
  internet/core/localredirectserver.cpp
  internet/magnatune/magnatunedownloaddialog.cpp
  internet/magnatune/magnatuneplaylistitem.cpp
  internet/magnatune/magnatuneservice.cpp
  internet/magnatune/magnatunesettingspage.cpp
  internet/magnatune/magnatuneurlhandler.cpp
  internet/core/oauthenticator.cpp
  internet/internetradio/savedradio.cpp
  internet/core/searchboxwidget.cpp
  internet/somafm/somafmservice.cpp
  internet/somafm/somafmurlhandler.cpp
  internet/intergalacticfm/intergalacticfmservice.cpp
  internet/intergalacticfm/intergalacticfmurlhandler.cpp
  internet/radiobrowser/radiobrowserservice.cpp
  internet/radiobrowser/radiobrowsersettingspage.cpp
  internet/radiobrowser/radiobrowserurlhandler.cpp
  internet/subsonic/subsonicservice.cpp
  internet/subsonic/subsonicsettingspage.cpp
  internet/subsonic/subsonicurlhandler.cpp
  internet/subsonic/subsonicdynamicplaylist.cpp

  library/groupbydialog.cpp
  library/library.cpp
  library/librarybackend.cpp
  library/librarydirectorymodel.cpp
  library/libraryfilterwidget.cpp
  library/librarymodel.cpp
  library/libraryplaylistitem.cpp
  library/libraryquery.cpp
  library/librarysettingspage.cpp
  library/libraryview.cpp
  library/libraryviewcontainer.cpp
  library/librarywatcher.cpp
  library/savedgroupingmanager.cpp
  library/sqlrow.cpp

  musicbrainz/acoustidclient.cpp
  musicbrainz/chromaprinter.cpp
  musicbrainz/musicbrainzclient.cpp
  musicbrainz/tagfetcher.cpp

  networkremote/incomingdataparser.cpp
  networkremote/networkremote.cpp
  networkremote/networkremotehelper.cpp
  networkremote/outgoingdatacreator.cpp
  networkremote/remoteclient.cpp
  networkremote/songsender.cpp
  networkremote/zeroconf.cpp

  playlist/dbplaylistitem.cpp
  playlist/dynamicplaylistcontrols.cpp
  playlist/playlist.cpp
  playlist/playlistbackend.cpp
  playlist/playlistcontainer.cpp
  playlist/playlistdelegates.cpp
  playlist/playlistfilterparser.cpp
  playlist/playlistfilter.cpp
  playlist/playlistheader.cpp
  playlist/playlistitem.cpp
  playlist/playlistlistcontainer.cpp
  playlist/playlistlistmodel.cpp
  playlist/playlistlistview.cpp
  playlist/playlistmanager.cpp
  playlist/playlistsaveoptionsdialog.cpp
  playlist/playlistsequence.cpp
  playlist/playlisttabbar.cpp
  playlist/playlistundocommands.cpp
  playlist/playlistview.cpp
  playlist/queue.cpp
  playlist/queuemanager.cpp
  playlist/songloaderinserter.cpp
  playlist/songplaylistitem.cpp

  playlistparsers/asxparser.cpp
  playlistparsers/asxiniparser.cpp
  playlistparsers/cueparser.cpp
  playlistparsers/m3uparser.cpp
  playlistparsers/parserbase.cpp
  playlistparsers/playlistparser.cpp
  playlistparsers/plsparser.cpp
  playlistparsers/wplparser.cpp
  playlistparsers/xmlparser.cpp
  playlistparsers/xspfparser.cpp

  internet/podcasts/addpodcastbyurl.cpp
  internet/podcasts/addpodcastdialog.cpp
  internet/podcasts/addpodcastpage.cpp
  internet/podcasts/episodeinfowidget.cpp
  internet/podcasts/fixedopmlpage.cpp
  internet/podcasts/gpoddersearchpage.cpp
  internet/podcasts/gpoddersync.cpp
  internet/podcasts/gpoddertoptagsmodel.cpp
  internet/podcasts/gpoddertoptagspage.cpp
  internet/podcasts/itunessearchpage.cpp
  internet/podcasts/podcast.cpp
  internet/podcasts/podcastbackend.cpp
  internet/podcasts/podcastdiscoverymodel.cpp
  internet/podcasts/podcastdeleter.cpp
  internet/podcasts/podcastdownloader.cpp
  internet/podcasts/podcastepisode.cpp
  internet/podcasts/podcastinfodialog.cpp
  internet/podcasts/podcastinfowidget.cpp
  internet/podcasts/podcastservice.cpp
  internet/podcasts/podcastservicemodel.cpp
  internet/podcasts/podcastsettingspage.cpp
  internet/podcasts/podcastparser.cpp
  internet/podcasts/podcastupdater.cpp
  internet/podcasts/podcasturlloader.cpp

  smartplaylists/generator.cpp
  smartplaylists/generatorinserter.cpp
  smartplaylists/querygenerator.cpp
  smartplaylists/querywizardplugin.cpp
  smartplaylists/search.cpp
  smartplaylists/searchpreview.cpp
  smartplaylists/searchterm.cpp
  smartplaylists/searchtermwidget.cpp
  smartplaylists/wizard.cpp
  smartplaylists/wizardplugin.cpp

  songinfo/artistbiography.cpp
  songinfo/artistinfoview.cpp
  songinfo/collapsibleinfoheader.cpp
  songinfo/collapsibleinfopane.cpp
  songinfo/songinfobase.cpp
  songinfo/songinfofetcher.cpp
  songinfo/songinfoprovider.cpp
  songinfo/songinfosettingspage.cpp
  songinfo/songinfotextview.cpp
  songinfo/songinfoview.cpp
  songinfo/songkickconcerts.cpp
  songinfo/songkickconcertwidget.cpp
  songinfo/songplaystats.cpp
  songinfo/spotifyimages.cpp
  songinfo/streamdiscoverer.cpp
  songinfo/taglyricsinfoprovider.cpp
  songinfo/ultimatelyricslyric.cpp
  songinfo/ultimatelyricsprovider.cpp
  songinfo/ultimatelyricsreader.cpp

  transcoder/transcodedialog.cpp
  transcoder/transcoder.cpp
  transcoder/transcoderoptionsaac.cpp
  transcoder/transcoderoptionsavaac.cpp
  transcoder/transcoderoptionsdialog.cpp
  transcoder/transcoderoptionserror.cpp
  transcoder/transcoderoptionsfdkaac.cpp
  transcoder/transcoderoptionsflac.cpp
  transcoder/transcoderoptionsmp3.cpp
  transcoder/transcoderoptionsopus.cpp
  transcoder/transcoderoptionsspeex.cpp
  transcoder/transcoderoptionsvoaac.cpp
  transcoder/transcoderoptionsvorbis.cpp
  transcoder/transcoderoptionswma.cpp
  transcoder/transcodersettingspage.cpp

  ui/about.cpp
  ui/addstreamdialog.cpp
  ui/albumcoverchoicecontroller.cpp
  ui/albumcoverexport.cpp
  ui/albumcovermanager.cpp
  ui/albumcovermanagerlist.cpp
  ui/albumcoversearcher.cpp
  ui/appearancesettingspage.cpp
  ui/backgroundstreamssettingspage.cpp
  ui/behavioursettingspage.cpp
  ui/console.cpp
  ui/coverfromurldialog.cpp
  ui/edittagdialog.cpp
  ui/lovedialog.cpp
  ui/equalizer.cpp
  ui/filechooserwidget.cpp
  ui/flowlayout.cpp
  ui/globalshortcutgrabber.cpp
  ui/globalshortcutssettingspage.cpp
  ui/iconloader.cpp
  ui/mainwindow.cpp
  ui/networkproxysettingspage.cpp
  ui/networkremotesettingspage.cpp
  ui/notificationssettingspage.cpp
  ui/organisedialog.cpp
  ui/organiseerrordialog.cpp
  ui/playbacksettingspage.cpp
  ui/qtsystemtrayicon.cpp
  ui/screensaver.cpp
  ui/settingscategory.cpp
  ui/settingsdialog.cpp
  ui/settingspage.cpp
  ui/splash.cpp
  ui/songmetadatasettingspage.cpp
  ui/standarditemiconloader.cpp

=== 3rdparty/qtiocompressor/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.0)

set(IOCOMPRESSOR-SOURCES
    qtiocompressor.cpp
)

set(IOCOMPRESSOR-MOC-HEADERS
    qtiocompressor.h
)

QT5_WRAP_CPP(IOCOMPRESSOR-SOURCES-MOC ${IOCOMPRESSOR-MOC-HEADERS})

ADD_LIBRARY(qtiocompressor STATIC
    ${IOCOMPRESSOR-SOURCES}
    ${IOCOMPRESSOR-SOURCES-MOC}
)

target_link_libraries(qtiocompressor Qt5::Core ${ZLIB_LIBRARIES})

=== 3rdparty/qtsingleapplication/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.0)

set(SINGLEAPP-SOURCES
    qtlocalpeer.cpp
    qtsingleapplication.cpp
    qtsinglecoreapplication.cpp
)

set(SINGLEAPP-MOC-HEADERS
    qtlocalpeer.h
    qtsingleapplication.h
    qtsinglecoreapplication.h
)

if(WIN32)
  set(SINGLEAPP-SOURCES ${SINGLEAPP-SOURCES} qtlockedfile_win.cpp)
elseif(WIN32)
  set(SINGLEAPP-SOURCES ${SINGLEAPP-SOURCES} qtlockedfile_unix.cpp)
endif(WIN32)

QT5_WRAP_CPP(SINGLEAPP-SOURCES-MOC ${SINGLEAPP-MOC-HEADERS})

ADD_LIBRARY(qtsingleapplication STATIC
    ${SINGLEAPP-SOURCES}
    ${SINGLEAPP-SOURCES-MOC}
)

target_link_libraries(qtsingleapplication Qt5::Core Qt5::Widgets Qt5::Network)

=== 3rdparty/qxt/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.0)
set(CMAKE_CXX_STANDARD 11)

set(QXT-SOURCES
  qxtglobal.cpp
  qxtglobalshortcut.cpp
)

set(QXT-MOC-HEADERS
  qxtglobalshortcut.h
)

include_directories(${X11_INCLUDE_DIR})
include_directories(${Qt5Gui_PRIVATE_INCLUDE_DIRS})

if(WIN32)
  set(QXT-SOURCES ${QXT-SOURCES} qxtglobalshortcut_win.cpp)
elseif(APPLE)
  set(QXT-SOURCES ${QXT-SOURCES} qxtglobalshortcut_mac.cpp)
else(WIN32)
  set(QXT-SOURCES ${QXT-SOURCES} qxtglobalshortcut_x11.cpp)
endif(WIN32)

QT5_WRAP_CPP(QXT-SOURCES-MOC ${QXT-MOC-HEADERS})

ADD_LIBRARY(qxt STATIC
  ${QXT-SOURCES}
  ${QXT-SOURCES-MOC}
)

if(WIN32)
  target_link_libraries(qxt Qt5::Core Qt5::Widgets)
else(WIN32)
  target_link_libraries(qxt Qt5::Core Qt5::Widgets Qt5::X11Extras)
endif(WIN32)

=== ext/libclementine-common/CMakeLists.txt ===
include_directories(${PROTOBUF_INCLUDE_DIRS})
include_directories(${CMAKE_CURRENT_BINARY_DIR})
include_directories(${CMAKE_CURRENT_SOURCE_DIR})

set(SOURCES
  core/closure.cpp
  core/latch.cpp
  core/logging.cpp
  core/messagehandler.cpp
  core/messagereply.cpp
  core/waitforsignal.cpp
  core/workerpool.cpp
)

set(HEADERS
  core/closure.h
  core/latch.h
  core/messagehandler.h
  core/messagereply.h
  core/workerpool.h
)

if(APPLE)
  list(APPEND SOURCES core/scoped_nsautorelease_pool.mm)
endif(APPLE)

qt5_wrap_cpp(MOC ${HEADERS})

add_library(libclementine-common STATIC
  ${SOURCES}
  ${MOC}
)

target_link_libraries(libclementine-common
  Qt5::Core
  Qt5::Network
  ${TAGLIB_LIBRARIES}
  ${CMAKE_THREAD_LIBS_INIT}
)

find_package(Backtrace)
configure_file(core/conf_backtrace.h.in conf_backtrace.h)

=== ext/libclementine-remote/CMakeLists.txt ===
include_directories(${PROTOBUF_INCLUDE_DIRS})

set(MESSAGES
  remotecontrolmessages.proto
)

add_library(libclementine-remote STATIC
  ${MESSAGES}
)

protobuf_generate(TARGET libclementine-remote LANGUAGE cpp)

target_link_libraries(libclementine-remote
  libclementine-common
  protobuf::libprotobuf
)

=== ext/libclementine-tagreader/CMakeLists.txt ===
include_directories(${PROTOBUF_INCLUDE_DIRS})
include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${CMAKE_CURRENT_BINARY_DIR})
include_directories(${CMAKE_SOURCE_DIR}/ext/libclementine-common)

set(MESSAGES
  tagreadermessages.proto
)

set(SOURCES
  fmpsparser.cpp
  tagreader.cpp
  gmereader.cpp
)

set(HEADERS
)

optional_source(HAVE_GOOGLE_DRIVE
  INCLUDE_DIRECTORIES ${SPARSEHASH_INCLUDE_DIRS}
  SOURCES
    cloudstream.cpp
  HEADERS
    cloudstream.h
)

qt5_wrap_cpp(MOC ${HEADERS})

add_library(libclementine-tagreader STATIC
  ${MESSAGES}
  ${SOURCES}
  ${MOC}
)

protobuf_generate(TARGET libclementine-tagreader LANGUAGE cpp)

target_link_libraries(libclementine-tagreader
  libclementine-common
  protobuf::libprotobuf
)

=== gst/moodbar/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.0)

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Woverloaded-virtual -Wall")

include_directories(${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR})

include_directories(${GLIB_INCLUDE_DIRS})
include_directories(${GOBJECT_INCLUDE_DIRS})
include_directories(${GSTREAMER_INCLUDE_DIRS})
include_directories(${FFTW3_INCLUDE_DIR})

set(SOURCES
  gstfastspectrum.cpp
  plugin.cpp
)

add_library(gstmoodbar STATIC
  ${SOURCES}
)

target_link_libraries(gstmoodbar
  ${GOBJECT_LIBRARIES}
  ${GLIB_LIBRARIES}
  ${GSTREAMER_LIBRARIES}
  ${GSTREAMER_AUDIO_LIBRARIES}
  ${GSTREAMER_BASE_LIBRARIES}
  ${FFTW3_FFTW_LIBRARY}
)

target_link_libraries(gstmoodbar Qt5::Core)

## clementine 1.4.1+git27-g658f34ec4+dfsg

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: clementine
 Section: sound
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian QA Group <packages@qa.debian.org>
+Maintainer: Debian QA Group <packages@qa.debian.org>
 Build-Depends:
  debhelper-compat (= 13),
  cmake (>= 2.6),

=== debian/rules ===
#!/usr/bin/make -f

export DEB_CXXFLAGS_MAINT_APPEND = -DQT_NO_DEBUG_OUTPUT -DQT_NO_WARNING_OUTPUT
export DEB_VERSION = $(shell dpkg-parsechangelog | egrep '^Version:' | cut -f 2 -d ' ')

%:
	dh $@ --buildsystem=cmake

# Also implicitly: -DHAVE_VISUALISATIONS=OFF -DVISUALISATIONS=OFF
override_dh_auto_configure:
	dh_auto_configure -- \
	    -DBUNDLE_PROJECTM_PRESETS=OFF \
	    -DFORCE_GIT_REVISION=$(DEB_VERSION)

override_dh_auto_clean:
	rm -fv dist/Info.plist
	rm -fv dist/clementine.spec
	rm -fv dist/maketarball.sh
	rm -fv dist/windows/clementine.nsi
	rm -fv dist/windows/clementine-portable.nsi
	rm -fv src/translations/translations.pot
	dh_auto_clean

override_dh_installchangelogs:
	dh_installchangelogs Changelog

override_dh_auto_test:
